/* runner.c generated by valac 0.48.9, the Vala compiler
 * generated from runner.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#define GAMES_TYPE_RUNNER (games_runner_get_type ())
#define GAMES_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_RUNNER, GamesRunner))
#define GAMES_IS_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_RUNNER))
#define GAMES_RUNNER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GAMES_TYPE_RUNNER, GamesRunnerIface))

typedef struct _GamesRunner GamesRunner;
typedef struct _GamesRunnerIface GamesRunnerIface;

#define GAMES_TYPE_HEADER_BAR_WIDGET (games_header_bar_widget_get_type ())
#define GAMES_HEADER_BAR_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_HEADER_BAR_WIDGET, GamesHeaderBarWidget))
#define GAMES_IS_HEADER_BAR_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_HEADER_BAR_WIDGET))
#define GAMES_HEADER_BAR_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GAMES_TYPE_HEADER_BAR_WIDGET, GamesHeaderBarWidgetIface))

typedef struct _GamesHeaderBarWidget GamesHeaderBarWidget;
typedef struct _GamesHeaderBarWidgetIface GamesHeaderBarWidgetIface;

#define GAMES_TYPE_SNAPSHOT (games_snapshot_get_type ())
#define GAMES_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_SNAPSHOT, GamesSnapshot))
#define GAMES_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_SNAPSHOT, GamesSnapshotClass))
#define GAMES_IS_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_SNAPSHOT))
#define GAMES_IS_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_SNAPSHOT))
#define GAMES_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_SNAPSHOT, GamesSnapshotClass))

typedef struct _GamesSnapshot GamesSnapshot;
typedef struct _GamesSnapshotClass GamesSnapshotClass;
typedef enum  {
	GAMES_INPUT_MODE_NONE,
	GAMES_INPUT_MODE_KEYBOARD,
	GAMES_INPUT_MODE_GAMEPAD
} GamesInputMode;

#define GAMES_TYPE_INPUT_MODE (games_input_mode_get_type ())

#define GAMES_TYPE_MEDIA_SET (games_media_set_get_type ())
#define GAMES_MEDIA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_MEDIA_SET, GamesMediaSet))
#define GAMES_MEDIA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_MEDIA_SET, GamesMediaSetClass))
#define GAMES_IS_MEDIA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_MEDIA_SET))
#define GAMES_IS_MEDIA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_MEDIA_SET))
#define GAMES_MEDIA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_MEDIA_SET, GamesMediaSetClass))

typedef struct _GamesMediaSet GamesMediaSet;
typedef struct _GamesMediaSetClass GamesMediaSetClass;
enum  {
	GAMES_RUNNER_SNAPSHOT_CREATED_SIGNAL,
	GAMES_RUNNER_STOPPED_SIGNAL,
	GAMES_RUNNER_CRASH_SIGNAL,
	GAMES_RUNNER_NUM_SIGNALS
};
static guint games_runner_signals[GAMES_RUNNER_NUM_SIGNALS] = {0};

struct _GamesHeaderBarWidgetIface {
	GTypeInterface parent_iface;
	gboolean (*get_block_autohide) (GamesHeaderBarWidget* self);
};

typedef enum  {
	GAMES_RUNNER_ERROR_UNSUPPORTED_SYSTEM,
	GAMES_RUNNER_ERROR_INVALID_GAME,
	GAMES_RUNNER_ERROR_OTHER
} GamesRunnerError;
#define GAMES_RUNNER_ERROR games_runner_error_quark ()
struct _GamesRunnerIface {
	GTypeInterface parent_iface;
	GtkWidget* (*get_display) (GamesRunner* self);
	GamesHeaderBarWidget* (*get_extra_widget) (GamesRunner* self);
	void (*prepare) (GamesRunner* self, GError** error);
	void (*start) (GamesRunner* self, GError** error);
	void (*resume) (GamesRunner* self);
	void (*pause) (GamesRunner* self);
	void (*stop) (GamesRunner* self);
	GamesSnapshot* (*try_create_snapshot) (GamesRunner* self, gboolean is_automatic);
	void (*delete_snapshot) (GamesRunner* self, GamesSnapshot* snapshot);
	void (*preview_snapshot) (GamesRunner* self, GamesSnapshot* snapshot);
	void (*preview_current_state) (GamesRunner* self);
	void (*load_previewed_snapshot) (GamesRunner* self, GError** error);
	GamesSnapshot** (*get_snapshots) (GamesRunner* self, gint* result_length1);
	GamesInputMode* (*get_available_input_modes) (GamesRunner* self, gint* result_length1);
	gboolean (*key_press_event) (GamesRunner* self, guint keyval, GdkModifierType state);
	gboolean (*gamepad_button_press_event) (GamesRunner* self, guint16 button);
	gboolean (*get_can_fullscreen) (GamesRunner* self);
	gboolean (*get_can_resume) (GamesRunner* self);
	gboolean (*get_supports_snapshots) (GamesRunner* self);
	gboolean (*get_is_integrated) (GamesRunner* self);
	GamesMediaSet* (*get_media_set) (GamesRunner* self);
	GamesInputMode (*get_input_mode) (GamesRunner* self);
	void (*set_input_mode) (GamesRunner* self, GamesInputMode value);
};

GType games_header_bar_widget_get_type (void) G_GNUC_CONST;
GQuark games_runner_error_quark (void);
GType games_snapshot_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesSnapshot, g_object_unref)
GType games_input_mode_get_type (void) G_GNUC_CONST;
GType games_media_set_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesMediaSet, g_object_unref)
GType games_runner_get_type (void) G_GNUC_CONST;
GtkWidget* games_runner_get_display (GamesRunner* self);
GamesHeaderBarWidget* games_runner_get_extra_widget (GamesRunner* self);
void games_runner_prepare (GamesRunner* self,
                           GError** error);
void games_runner_start (GamesRunner* self,
                         GError** error);
void games_runner_resume (GamesRunner* self);
void games_runner_pause (GamesRunner* self);
void games_runner_stop (GamesRunner* self);
GamesSnapshot* games_runner_try_create_snapshot (GamesRunner* self,
                                                 gboolean is_automatic);
void games_runner_delete_snapshot (GamesRunner* self,
                                   GamesSnapshot* snapshot);
void games_runner_preview_snapshot (GamesRunner* self,
                                    GamesSnapshot* snapshot);
void games_runner_preview_current_state (GamesRunner* self);
void games_runner_load_previewed_snapshot (GamesRunner* self,
                                           GError** error);
GamesSnapshot** games_runner_get_snapshots (GamesRunner* self,
                                            gint* result_length1);
GamesInputMode* games_runner_get_available_input_modes (GamesRunner* self,
                                                        gint* result_length1);
gboolean games_runner_key_press_event (GamesRunner* self,
                                       guint keyval,
                                       GdkModifierType state);
gboolean games_runner_gamepad_button_press_event (GamesRunner* self,
                                                  guint16 button);
gboolean games_runner_get_can_fullscreen (GamesRunner* self);
gboolean games_runner_get_can_resume (GamesRunner* self);
gboolean games_runner_get_supports_snapshots (GamesRunner* self);
gboolean games_runner_get_is_integrated (GamesRunner* self);
GamesMediaSet* games_runner_get_media_set (GamesRunner* self);
GamesInputMode games_runner_get_input_mode (GamesRunner* self);
void games_runner_set_input_mode (GamesRunner* self,
                                  GamesInputMode value);
static GType games_runner_get_type_once (void);

GtkWidget*
games_runner_get_display (GamesRunner* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_display (self);
}

GamesHeaderBarWidget*
games_runner_get_extra_widget (GamesRunner* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_extra_widget (self);
}

void
games_runner_prepare (GamesRunner* self,
                      GError** error)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->prepare (self, error);
}

void
games_runner_start (GamesRunner* self,
                    GError** error)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->start (self, error);
}

void
games_runner_resume (GamesRunner* self)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->resume (self);
}

void
games_runner_pause (GamesRunner* self)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->pause (self);
}

void
games_runner_stop (GamesRunner* self)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->stop (self);
}

GamesSnapshot*
games_runner_try_create_snapshot (GamesRunner* self,
                                  gboolean is_automatic)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GAMES_RUNNER_GET_INTERFACE (self)->try_create_snapshot (self, is_automatic);
}

void
games_runner_delete_snapshot (GamesRunner* self,
                              GamesSnapshot* snapshot)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->delete_snapshot (self, snapshot);
}

void
games_runner_preview_snapshot (GamesRunner* self,
                               GamesSnapshot* snapshot)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->preview_snapshot (self, snapshot);
}

void
games_runner_preview_current_state (GamesRunner* self)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->preview_current_state (self);
}

void
games_runner_load_previewed_snapshot (GamesRunner* self,
                                      GError** error)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->load_previewed_snapshot (self, error);
}

GamesSnapshot**
games_runner_get_snapshots (GamesRunner* self,
                            gint* result_length1)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_snapshots (self, result_length1);
}

GamesInputMode*
games_runner_get_available_input_modes (GamesRunner* self,
                                        gint* result_length1)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_available_input_modes (self, result_length1);
}

gboolean
games_runner_key_press_event (GamesRunner* self,
                              guint keyval,
                              GdkModifierType state)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GAMES_RUNNER_GET_INTERFACE (self)->key_press_event (self, keyval, state);
}

gboolean
games_runner_gamepad_button_press_event (GamesRunner* self,
                                         guint16 button)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GAMES_RUNNER_GET_INTERFACE (self)->gamepad_button_press_event (self, button);
}

gboolean
games_runner_get_can_fullscreen (GamesRunner* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_can_fullscreen (self);
}

gboolean
games_runner_get_can_resume (GamesRunner* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_can_resume (self);
}

gboolean
games_runner_get_supports_snapshots (GamesRunner* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_supports_snapshots (self);
}

gboolean
games_runner_get_is_integrated (GamesRunner* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_is_integrated (self);
}

GamesMediaSet*
games_runner_get_media_set (GamesRunner* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_media_set (self);
}

GamesInputMode
games_runner_get_input_mode (GamesRunner* self)
{
	g_return_val_if_fail (self != NULL, 0);
	return GAMES_RUNNER_GET_INTERFACE (self)->get_input_mode (self);
}

void
games_runner_set_input_mode (GamesRunner* self,
                             GamesInputMode value)
{
	g_return_if_fail (self != NULL);
	GAMES_RUNNER_GET_INTERFACE (self)->set_input_mode (self, value);
}

static void
games_runner_default_init (GamesRunnerIface * iface,
                           gpointer iface_data)
{
	g_object_interface_install_property (iface, g_param_spec_boolean ("can-fullscreen", "can-fullscreen", "can-fullscreen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_interface_install_property (iface, g_param_spec_boolean ("can-resume", "can-resume", "can-resume", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_interface_install_property (iface, g_param_spec_boolean ("supports-snapshots", "supports-snapshots", "supports-snapshots", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_interface_install_property (iface, g_param_spec_boolean ("is-integrated", "is-integrated", "is-integrated", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_interface_install_property (iface, g_param_spec_object ("media-set", "media-set", "media-set", GAMES_TYPE_MEDIA_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_interface_install_property (iface, g_param_spec_enum ("input-mode", "input-mode", "input-mode", GAMES_TYPE_INPUT_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	games_runner_signals[GAMES_RUNNER_SNAPSHOT_CREATED_SIGNAL] = g_signal_new ("snapshot-created", GAMES_TYPE_RUNNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	games_runner_signals[GAMES_RUNNER_STOPPED_SIGNAL] = g_signal_new ("stopped", GAMES_TYPE_RUNNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	games_runner_signals[GAMES_RUNNER_CRASH_SIGNAL] = g_signal_new ("crash", GAMES_TYPE_RUNNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}

static GType
games_runner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesRunnerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_runner_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType games_runner_type_id;
	games_runner_type_id = g_type_register_static (G_TYPE_INTERFACE, "GamesRunner", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (games_runner_type_id, G_TYPE_OBJECT);
	return games_runner_type_id;
}

GType
games_runner_get_type (void)
{
	static volatile gsize games_runner_type_id__volatile = 0;
	if (g_once_init_enter (&games_runner_type_id__volatile)) {
		GType games_runner_type_id;
		games_runner_type_id = games_runner_get_type_once ();
		g_once_init_leave (&games_runner_type_id__volatile, games_runner_type_id);
	}
	return games_runner_type_id__volatile;
}

