/* error-display.c generated by valac 0.48.9, the Vala compiler
 * generated from error-display.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define GAMES_TYPE_ERROR_DISPLAY (games_error_display_get_type ())
#define GAMES_ERROR_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_ERROR_DISPLAY, GamesErrorDisplay))
#define GAMES_ERROR_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_ERROR_DISPLAY, GamesErrorDisplayClass))
#define GAMES_IS_ERROR_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_ERROR_DISPLAY))
#define GAMES_IS_ERROR_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_ERROR_DISPLAY))
#define GAMES_ERROR_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_ERROR_DISPLAY, GamesErrorDisplayClass))

typedef struct _GamesErrorDisplay GamesErrorDisplay;
typedef struct _GamesErrorDisplayClass GamesErrorDisplayClass;
typedef struct _GamesErrorDisplayPrivate GamesErrorDisplayPrivate;
enum  {
	GAMES_ERROR_DISPLAY_0_PROPERTY,
	GAMES_ERROR_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* games_error_display_properties[GAMES_ERROR_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAMES_TYPE_GAME (games_game_get_type ())
#define GAMES_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_GAME, GamesGame))
#define GAMES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_GAME, GamesGameClass))
#define GAMES_IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_GAME))
#define GAMES_IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_GAME))
#define GAMES_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_GAME, GamesGameClass))

typedef struct _GamesGame GamesGame;
typedef struct _GamesGameClass GamesGameClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GamesErrorDisplay {
	GtkBox parent_instance;
	GamesErrorDisplayPrivate * priv;
};

struct _GamesErrorDisplayClass {
	GtkBoxClass parent_class;
};

struct _GamesErrorDisplayPrivate {
	GtkLabel* primary_label;
	GtkLabel* secondary_label;
	GtkButton* restart_btn;
};

static gint GamesErrorDisplay_private_offset;
static gpointer games_error_display_parent_class = NULL;

GType games_error_display_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesErrorDisplay, g_object_unref)
GType games_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesGame, g_object_unref)
void games_error_display_running_game_failed (GamesErrorDisplay* self,
                                              GamesGame* game,
                                              const gchar* message);
const gchar* games_game_get_name (GamesGame* self);
static void games_error_display_set_labels (GamesErrorDisplay* self,
                                     const gchar* primary,
                                     const gchar* secondary);
void games_error_display_game_crashed (GamesErrorDisplay* self,
                                       GamesGame* game,
                                       const gchar* message);
GamesErrorDisplay* games_error_display_new (void);
GamesErrorDisplay* games_error_display_construct (GType object_type);
static void games_error_display_finalize (GObject * obj);
static GType games_error_display_get_type_once (void);

static inline gpointer
games_error_display_get_instance_private (GamesErrorDisplay* self)
{
	return G_STRUCT_MEMBER_P (self, GamesErrorDisplay_private_offset);
}

void
games_error_display_running_game_failed (GamesErrorDisplay* self,
                                         GamesGame* game,
                                         const gchar* message)
{
	gchar* title = NULL;
	const gchar* _tmp4_;
	GtkButton* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (game != NULL);
	g_return_if_fail (message != NULL);
	if (game != NULL) {
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = games_game_get_name (game);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_strdup_printf (_ ("Oops! Unable to run “%s”"), _tmp1_);
		_g_free0 (title);
		title = _tmp2_;
	} else {
		gchar* _tmp3_;
		_tmp3_ = g_strdup (_ ("Oops! Unable to run the game"));
		_g_free0 (title);
		title = _tmp3_;
	}
	_tmp4_ = title;
	games_error_display_set_labels (self, _tmp4_, message);
	_tmp5_ = self->priv->restart_btn;
	gtk_widget_hide ((GtkWidget*) _tmp5_);
	_g_free0 (title);
}

void
games_error_display_game_crashed (GamesErrorDisplay* self,
                                  GamesGame* game,
                                  const gchar* message)
{
	gchar* title = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GtkButton* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (game != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = games_game_get_name (game);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf (_ ("Oops! The game “%s” crashed unexpectedly"), _tmp1_);
	title = _tmp2_;
	games_error_display_set_labels (self, title, message);
	_tmp3_ = self->priv->restart_btn;
	gtk_widget_show ((GtkWidget*) _tmp3_);
	_g_free0 (title);
}

static void
games_error_display_set_labels (GamesErrorDisplay* self,
                                const gchar* primary,
                                const gchar* secondary)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (primary != NULL);
	g_return_if_fail (secondary != NULL);
	_tmp0_ = self->priv->primary_label;
	gtk_label_set_label (_tmp0_, primary);
	_tmp1_ = self->priv->secondary_label;
	gtk_label_set_label (_tmp1_, secondary);
}

GamesErrorDisplay*
games_error_display_construct (GType object_type)
{
	GamesErrorDisplay * self = NULL;
	self = (GamesErrorDisplay*) g_object_new (object_type, NULL);
	return self;
}

GamesErrorDisplay*
games_error_display_new (void)
{
	return games_error_display_construct (GAMES_TYPE_ERROR_DISPLAY);
}

static void
games_error_display_class_init (GamesErrorDisplayClass * klass,
                                gpointer klass_data)
{
	games_error_display_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GamesErrorDisplay_private_offset);
	G_OBJECT_CLASS (klass)->finalize = games_error_display_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Games/ui/error-display.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "primary_label", FALSE, GamesErrorDisplay_private_offset + G_STRUCT_OFFSET (GamesErrorDisplayPrivate, primary_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "secondary_label", FALSE, GamesErrorDisplay_private_offset + G_STRUCT_OFFSET (GamesErrorDisplayPrivate, secondary_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "restart_btn", FALSE, GamesErrorDisplay_private_offset + G_STRUCT_OFFSET (GamesErrorDisplayPrivate, restart_btn));
}

static void
games_error_display_instance_init (GamesErrorDisplay * self,
                                   gpointer klass)
{
	self->priv = games_error_display_get_instance_private (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
games_error_display_finalize (GObject * obj)
{
	GamesErrorDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_ERROR_DISPLAY, GamesErrorDisplay);
	_g_object_unref0 (self->priv->primary_label);
	_g_object_unref0 (self->priv->secondary_label);
	_g_object_unref0 (self->priv->restart_btn);
	G_OBJECT_CLASS (games_error_display_parent_class)->finalize (obj);
}

static GType
games_error_display_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesErrorDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_error_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesErrorDisplay), 0, (GInstanceInitFunc) games_error_display_instance_init, NULL };
	GType games_error_display_type_id;
	games_error_display_type_id = g_type_register_static (gtk_box_get_type (), "GamesErrorDisplay", &g_define_type_info, 0);
	GamesErrorDisplay_private_offset = g_type_add_instance_private (games_error_display_type_id, sizeof (GamesErrorDisplayPrivate));
	return games_error_display_type_id;
}

GType
games_error_display_get_type (void)
{
	static volatile gsize games_error_display_type_id__volatile = 0;
	if (g_once_init_enter (&games_error_display_type_id__volatile)) {
		GType games_error_display_type_id;
		games_error_display_type_id = games_error_display_get_type_once ();
		g_once_init_leave (&games_error_display_type_id__volatile, games_error_display_type_id);
	}
	return games_error_display_type_id__volatile;
}

