/* fingerprint.c generated by valac 0.48.9, the Vala compiler
 * generated from fingerprint.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define GAMES_TYPE_URI (games_uri_get_type ())
#define GAMES_URI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_URI, GamesUri))
#define GAMES_URI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_URI, GamesUriClass))
#define GAMES_IS_URI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_URI))
#define GAMES_IS_URI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_URI))
#define GAMES_URI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_URI, GamesUriClass))

typedef struct _GamesUri GamesUri;
typedef struct _GamesUriClass GamesUriClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

gpointer games_uri_ref (gpointer instance);
void games_uri_unref (gpointer instance);
GParamSpec* games_param_spec_uri (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void games_value_set_uri (GValue* value,
                          gpointer v_object);
void games_value_take_uri (GValue* value,
                           gpointer v_object);
gpointer games_value_get_uri (const GValue* value);
GType games_uri_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesUri, games_uri_unref)
gchar* games_fingerprint_get_for_file_uri (GamesUri* uri,
                                           gsize start,
                                           gsize* length,
                                           GError** error);
GFile* games_uri_to_file (GamesUri* self);
gchar* games_fingerprint_get_for_file_input_stream (GFileInputStream* file_stream,
                                                    gsize start,
                                                    gsize* length,
                                                    GError** error);
gchar* games_fingerprint_get_uid (GamesUri* uri,
                                  const gchar* prefix,
                                  GError** error);
gchar* games_fingerprint_get_uid_for_chunk (GamesUri* uri,
                                            const gchar* prefix,
                                            gsize start,
                                            gsize length,
                                            GError** error);

gchar*
games_fingerprint_get_for_file_uri (GamesUri* uri,
                                    gsize start,
                                    gsize* length,
                                    GError** error)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFileInputStream* istream = NULL;
	GFile* _tmp1_;
	GFileInputStream* _tmp2_;
	gchar* _tmp3_ = NULL;
	GFileInputStream* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = games_uri_to_file (uri);
	file = _tmp0_;
	_tmp1_ = file;
	_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
	istream = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (file);
		return NULL;
	}
	_tmp4_ = istream;
	_tmp5_ = games_fingerprint_get_for_file_input_stream (_tmp4_, start, length, &_inner_error0_);
	_tmp3_ = _tmp5_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (istream);
		_g_object_unref0 (file);
		return NULL;
	}
	_tmp6_ = _tmp3_;
	_tmp3_ = NULL;
	result = _tmp6_;
	_g_free0 (_tmp3_);
	_g_object_unref0 (istream);
	_g_object_unref0 (file);
	return result;
}

gchar*
games_fingerprint_get_for_file_input_stream (GFileInputStream* file_stream,
                                             gsize start,
                                             gsize* length,
                                             GError** error)
{
	gsize size = 0UL;
	GBytes* bytes = NULL;
	GBytes* _tmp0_;
	GBytes* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (file_stream != NULL, NULL);
	if (length == NULL) {
		G_FILE_INPUT_STREAM_GET_CLASS (file_stream)->seek (file_stream, (gint64) 0, G_SEEK_END, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		}
		size = (gsize) G_FILE_INPUT_STREAM_GET_CLASS (file_stream)->tell (file_stream);
	} else {
		size = *length;
	}
	G_FILE_INPUT_STREAM_GET_CLASS (file_stream)->seek (file_stream, (gint64) start, G_SEEK_SET, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp0_ = g_input_stream_read_bytes ((GInputStream*) file_stream, size, NULL, &_inner_error0_);
	bytes = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp1_ = bytes;
	_tmp2_ = g_compute_checksum_for_bytes (G_CHECKSUM_MD5, _tmp1_);
	result = _tmp2_;
	_g_bytes_unref0 (bytes);
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

gchar*
games_fingerprint_get_uid (GamesUri* uri,
                           const gchar* prefix,
                           GError** error)
{
	gchar* fingerprint = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	g_return_val_if_fail (prefix != NULL, NULL);
	_tmp0_ = games_fingerprint_get_for_file_uri (uri, (gsize) 0, NULL, &_inner_error0_);
	fingerprint = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp1_ = string_to_string (prefix);
	_tmp2_ = string_to_string (fingerprint);
	_tmp3_ = g_strconcat (_tmp1_, "-", _tmp2_, NULL);
	result = _tmp3_;
	_g_free0 (fingerprint);
	return result;
}

gchar*
games_fingerprint_get_uid_for_chunk (GamesUri* uri,
                                     const gchar* prefix,
                                     gsize start,
                                     gsize length,
                                     GError** error)
{
	gchar* fingerprint = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	g_return_val_if_fail (prefix != NULL, NULL);
	_tmp0_ = games_fingerprint_get_for_file_uri (uri, start, &length, &_inner_error0_);
	fingerprint = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp1_ = string_to_string (prefix);
	_tmp2_ = string_to_string (fingerprint);
	_tmp3_ = g_strconcat (_tmp1_, "-", _tmp2_, NULL);
	result = _tmp3_;
	_g_free0 (fingerprint);
	return result;
}

